<?php

namespace Drupal\simple_glossary\Controller;
use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Component\Utility\SafeMarkup;

/**
 * Glossary Help 
 */

class GlossaryFrontendController {
	
	public function content(){
		return GlossaryFrontendController::fetchAllTermsFromDB('A');
	}

	public function contentByLetter($ltr = ''){
		return GlossaryFrontendController::fetchAllTermsFromDB($ltr);
	}

	public function fetchAllTermsFromDB($ltr = '') {
		global $base_url;
		if((isset($_GET['keyword'])) && (!empty($_GET['keyword'])) ) {
			$keywordLength = strlen($_GET['keyword']);
			if (( $keywordLength == 1 ) && (preg_match("/^[a-zA-Z]$/", strtoupper($_GET['keyword'])))) {
				$whereCondition  = "where (SUBSTR(term,1,1) = '".$_GET['keyword']."') ";  
			} else {
				$whereCondition  =  "where (term LIKE '%".$_GET['keyword']."%')"; 
			}
		} else if((isset($ltr)) && (!empty($ltr)) ) {
			$whereCondition  = "where (SUBSTR(term,1,1) = '".$ltr."')";  
		} else {
			$whereCondition  = "";  
		}
		$result  = db_query("SELECT * FROM simple_glossary_content ".$whereCondition." order by term ASC");
		$finalGlossaryResult = [];
		if(!empty($result)) {
			$glossaryResult = [];
			foreach ($result as $row) {
				$glossaryResult[] = (array)$row;
			}
			$j 		= 0;
			$temp 	= [];
			for($i=0; $i<count($glossaryResult); $i++) {
				$glossaryResult[$i]['term']        = ucfirst($glossaryResult[$i]['term']);
				$glossaryResult[$i]['description'] = html_entity_decode(str_replace('\,', ',', $glossaryResult[$i]['description']));
				$temp[] = $glossaryResult[$i];
				if(($j == 1) || (count($glossaryResult) == $i+1)) {
					$finalGlossaryResult[] =	$temp;
					unset($temp);
					$j = 0;
				} else {
					$j++;
				}
			}
		}
		$qry_string 			= [];
		$qry_string['keyword'] 	= (isset($_GET['keyword']))?$_GET['keyword']:'';
		$qry_string['ltr'] 		= (isset($ltr))?$ltr:'';
		
		$glossaryConfig 				              = [];
        $glossaryConfig['glossary_page_title']        = \Drupal::state()->get('glossary_page_title');
        $glossaryConfig['glossary_page_subheading']   = \Drupal::state()->get('glossary_page_subheading');
		$imagesTemp 						          = json_decode(\Drupal::state()->get('glossary_bg_image'));
		if(!empty($imagesTemp[0])) {
			$file 										  = \Drupal\file\Entity\File::load($imagesTemp[0]);
			$path 										  = $file->getFileUri();
			$glossaryConfig['glossary_bg_image'] 		  =	file_create_url($path); 
		} else {
			$glossaryConfig['glossary_bg_image'] ='';
		}
		$glossaryConfig['glossary_bottom_text']       = html_entity_decode(\Drupal::state()->get('glossary_bottom_text')); 
		
		return [
			'#theme' => 'forntend_list_view',
			'#terms_data' => $finalGlossaryResult,
			'#config' => $glossaryConfig,
			'#base_url'   => $base_url,
			'#qry_string' => $qry_string,
			'#attached'   => array(
				'library' => array(
				  'simple_glossary/simple_glossary_list_view_assets', 
				)
			)
		];
	}
}